Subject: RE: Access Control, Administrative Areas, Replication and Distribution

From: "Paul Leach" <[email-masked]>
Date: Mon, 26 Mar 2001 18:02:22 -0800

> -----Original Message-----
> From: Albert Langer [mailto:[email-masked]] 
> Sent: Monday, March 26, 2001 5:39 AM
> To: [email-masked]; [email-masked]
> Subject: Access Control, Administrative Areas, Replication 
> and Distribution
> 
> 
> Following links highlight serious problems that can arise 
> from not not working out access control together with 
> replication carefully enough.
> 
> Microsoft unable to supply a fix for more than a year due to 
> having to fundamentally redesign Active Directory to fix it:
> 
> http://www.nwfusion.com/archive/2001/117574_02-26-2001.html
> 
> http://www.microsoft.com/windows2000/news/bulletins/multivalrep.asp
> 
> Similar issues can arise with replication of administrative 
> policy etc.

Nonsense. The "fundamental" flaw is that Active Directory is loosely
consistent. It was proved almost two decades ago (by Brian Oki at PODC
1984, IIRC) that there is a hard instrinsic tradeoff between consistency
and availability. For many purposes, availability is more important.
Active Directory, and several other commercial products, are targeted at
this space, and LDUP is attempting to standardize such a protocol.

Many customers don't like intrinsic tradeoffs. They want both
consistency and high availability, even if it can be proved that it is
impossible. And almost no journalist understands any of this.

BTW: the fix to this "security flaw" was to make the unit of replication
finer grained. No "funadamental" redesign was needed.

You should use better evidence in your campaign.

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Wed, 28 Mar 2001 10:35:40 -0800

At 06:02 PM 3/26/01 -0800, Paul Leach wrote:
>The "fundamental" flaw is that Active Directory is loosely
>consistent.
>

I don't see how making replication finer grained removes
the "fundamental" flaw, "loose consistency" between masters.

Kurt

---

From: "Paul Leach" <[email-masked]>
Date: Wed, 28 Mar 2001 10:57:28 -0800

I didn't say it removed the "fundamental" flaw, just the "security
flaw".

The "security flaw" was that updates to objects that were really a
collection of finer grained objects were getting lost.

Scenario:
Big object X is composed of set of small objects {A, B, C, ...}
User 1 changes X to {A', B, C, ...}
User 2 changes X to {A, B', C, ...} before user 1's changes get to him.
Whichever one wins the conflict resolution, the other one's change is
lost. These are "false conflicts", analagous to "false sharing" in DSM
systems.

If instead, A, B, C, were individually replicatable objects, then this
wouldn't happen. Only conflicts on individual items would be subject to
conflict. That's intrinsic.

Users just didn't expect the updates to X to get lost -- X in this case
was a group of users, and they were operating on _different_ users, so
they expected it to work.

> From: Kurt D. Zeilenga [mailto:[email-masked]] 
> Sent: Wednesday, March 28, 2001 10:36 AM
> To: Paul Leach
> Cc: [email-masked]; [email-masked]; 
> [email-masked]
> Subject: RE: Access Control, Administrative Areas, 
> Replication and Distribution
> 
> 
> >BTW: the fix to this "security flaw" was to make the unit of 
> >replication finer grained. No "funadamental" redesign was needed.
>